## olm 2.2.2%2Bgit20170526.0fd768e%2Bdfsg

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts="mode=git,dversionmangle=s/\+dfsg//" http://matrix.org/git/olm.git \
   refs/tags/([\d\.]+) debian uupdate
