=== debian/changelog ===
olm (2.2.2+git20170526.0fd768e+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #847566)

 -- Hubert Chathi <uhoreg@debian.org>  Mon, 12 Jun 2017 19:18:08 -0400
