=== debian/control ===
Source: olm
Priority: optional
Maintainer: Hubert Chathi <uhoreg@debian.org>
Build-Depends: debhelper (>=9), dh-python, python-all-dev (>= 2.6.6-3~), python-docutils, python-pygments
Standards-Version: 3.9.8
Section: libs
Homepage: https://matrix.org/git/olm/
X-Python-Version: >= 2.7
#Vcs-Git: git://anonscm.debian.org/collab-maint/olm.git
#Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/olm.git

Package: libolm2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: implementation of the Double Ratchet cryptographic ratchet in C++
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
Multi-Arch: same

Package: libolm-dev
Section: libdevel
Architecture: any
Depends: libolm2 (= ${binary:Version}), ${misc:Depends}
Description: development files for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
 .
 This package contains the development files for compiling programs that use
 olm.
Multi-Arch: same

Package: python-olm
Section: python
Architecture: all
Depends: libolm2 (>= ${source:Version}), libolm2 (<< ${source:Version}.1~), ${misc:Depends}, ${python:Depends}, python-yaml
Description: Python bindings for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
 .
 This package contains the Python bindings for libolm.
