=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with python2

override_dh_auto_build:
	make
	make doc

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/libolm* debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	for v in `pyversions -vr`; do \
	  mkdir -p debian/python-olm/usr/lib/python$$v/dist-packages; \
	  cp -r python/olm debian/python-olm/usr/lib/python$$v/dist-packages; \
	done
