=== debian/changelog ===
olm (3.1.3+dfsg-2build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:21:23 +0100

olm (3.1.3+dfsg-2build1) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:27:06 +0000

olm (3.1.3+dfsg-2) unstable; urgency=medium

  * Drop Python2 package python-olm. (Closes: #937188)

 -- Hubert Chathi <uhoreg@debian.org>  Sat, 31 Aug 2019 13:29:22 -0700

olm (3.1.3+dfsg-1) unstable; urgency=medium

  * New upstream release.
    * New soname.  However, the C ABI is still compatible, so also provide the
      old soname.
    * New python 3 package.

 -- Hubert Chathi <uhoreg@debian.org>  Tue, 25 Jun 2019 11:56:55 -0400
