=== debian/control ===
--- 
+++ 
@@ -1,17 +1,24 @@
 Source: olm
 Priority: optional
 Maintainer: Hubert Chathi <uhoreg@debian.org>
-Build-Depends: debhelper (>=9), dh-python, python-all-dev (>= 2.6.6-3~), python-docutils, python-pygments
-Standards-Version: 3.9.8
+Build-Depends: cmake
+ , debhelper (>=10)
+ , dh-python
+ , python3-all-dev (>= 3.7)
+ , python3-cffi
+ , python3-setuptools
+Standards-Version: 4.3.0
 Section: libs
 Homepage: https://matrix.org/git/olm/
-X-Python-Version: >= 2.7
 #Vcs-Git: git://anonscm.debian.org/collab-maint/olm.git
 #Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/olm.git
 
-Package: libolm2
+Package: libolm3
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Conflicts: libolm2
+Replaces: libolm2
+Provides: libolm2
 Description: implementation of the Double Ratchet cryptographic ratchet in C++
  Olm is an implementation of the Double Ratchet cryptographic ratchet described
  by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
@@ -29,7 +36,7 @@
 Package: libolm-dev
 Section: libdevel
 Architecture: any
-Depends: libolm2 (= ${binary:Version}), ${misc:Depends}
+Depends: libolm3 (= ${binary:Version}), ${misc:Depends}
 Description: development files for the olm Double Ratchet implementation
  Olm is an implementation of the Double Ratchet cryptographic ratchet described
  by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
@@ -47,10 +54,10 @@
  olm.
 Multi-Arch: same
 
-Package: python-olm
+Package: python3-olm
 Section: python
-Architecture: all
-Depends: libolm2 (>= ${source:Version}), libolm2 (<< ${source:Version}.1~), ${misc:Depends}, ${python:Depends}, python-yaml
+Architecture: any
+Depends: libolm3 (>= ${source:Version}), libolm3 (<< ${source:Version}.1~), ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
 Description: Python bindings for the olm Double Ratchet implementation
  Olm is an implementation of the Double Ratchet cryptographic ratchet described
  by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
@@ -64,4 +71,4 @@
  Megolm is the end-to-end encryption system for the Matrix communications
  protocol.
  .
- This package contains the Python bindings for libolm.
+ This package contains the Python 3 bindings for libolm.
