=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

opts=dversionmangle=s/\+dfsg\d*$//,filenamemangle=s/.*\/archive\/(\d\S+)\/olm.*\.tar\.bz2/olm-$1\.tar\.bz2/g \
  https://gitlab.matrix.org/matrix-org/olm/tags?sort=updated_desc .*/archive/(\d\S+)/.*\.tar\.bz2.*
