=== debian/changelog ===
olm (3.1.4~dfsg-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Lower debhelper-compat to 11 for dwz compatibility

 -- Pirate Praveen <praveen@debian.org>  Sat, 13 Jun 2020 14:59:57 +0530

olm (3.1.4~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * add git-buildpackage configuration:
    + use pristine-tar
    + sign tags
    + ignore any .git files
  * copyright:
    + document files stripped from repackaged source
    + merge identically licensed Files sections
    + separate upstream verbatim License-Grant
      from authored License-Reference
    + list licenses as sections below Files sections
    + fix cover files licensed Expat or ISC
    + extend coverage
    + add myself as copyright holder
    + relicense packaging as GPL-3+
  * drop file README.source (obsolete)
  * add lintian overrides for use of License-Grant and License-Reference
  * watch:
    + use dversionmangle=auto
    + use repacksuffix=~dfsg (to support upstream cleaned rerelease)
    + drop filenamemangle (unneeded)
    + simplify download URL and regular expression
    + add usage comment
  * add helper script copyright-check to source
  * fix support DEB_BUILD_OPTIONS=nocheck
  * update control fields Maintainer Uploader Vcs-*:
    packaging moved to the Matrix Packaging Team
  * use debhelper compatibility level 12 (not 10);
    build-depend on debhelper-compat dh-sequence-python3
    (not debhelper dh-python)

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 08 Apr 2020 18:13:41 +0200
